summaryrefslogtreecommitdiff
path: root/tests.branching
diff options
context:
space:
mode:
authorSam Thursfield <sam.thursfield@codethink.co.uk>2012-09-03 14:41:43 +0100
committerSam Thursfield <sam.thursfield@codethink.co.uk>2012-09-03 14:41:43 +0100
commit15e12781bf84663c31aeba846107d80df81e770a (patch)
tree4175fc2902a6db3eff76cf30b9c26d8f8601e641 /tests.branching
parentd415901bc394c64752b54089427b7b0b5638ca2a (diff)
parentf9718b4dcc172763c1dd46bc805b6bde03ec3706 (diff)
downloadmorph-15e12781bf84663c31aeba846107d80df81e770a.tar.gz
Merge branch 'jannis/find-repos-using-git-config-option'
Conflicts: morphlib/plugins/branch_and_merge_plugin.py
Diffstat (limited to 'tests.branching')
-rwxr-xr-xtests.branching/edit-works-after-branch-root-was-renamed.script34
-rw-r--r--tests.branching/edit-works-after-branch-root-was-renamed.stdout18
-rwxr-xr-xtests.branching/morph-repository-stored-in-cloned-repositories.script47
-rw-r--r--tests.branching/morph-repository-stored-in-cloned-repositories.stdout8
4 files changed, 107 insertions, 0 deletions
diff --git a/tests.branching/edit-works-after-branch-root-was-renamed.script b/tests.branching/edit-works-after-branch-root-was-renamed.script
new file mode 100755
index 00000000..da8fb0b7
--- /dev/null
+++ b/tests.branching/edit-works-after-branch-root-was-renamed.script
@@ -0,0 +1,34 @@
+#!/bin/sh
+# Copyright (C) 2012 Codethink Limited
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
+# Verify that the branch root repository created by "morph branch" or
+# "morph checkout" can be renamed and "morph edit" still finds the
+# branch root repo and works.
+
+set -eu
+
+cd "$DATADIR/workspace"
+
+"$SRCDIR/scripts/test-morph" init
+"$SRCDIR/scripts/test-morph" checkout baserock:morphs master
+
+cd "$DATADIR/workspace/master"
+mv baserock:morphs my-renamed-morphs
+
+"$SRCDIR/scripts/test-morph" edit baserock:hello master
+
+"$SRCDIR/scripts/list-tree" "$DATADIR/workspace" | grep -v '/\.git/' |
+ sed 's,/cache/gits/file_[^/]*_,/cache/gits/file_,'
diff --git a/tests.branching/edit-works-after-branch-root-was-renamed.stdout b/tests.branching/edit-works-after-branch-root-was-renamed.stdout
new file mode 100644
index 00000000..5cfe475f
--- /dev/null
+++ b/tests.branching/edit-works-after-branch-root-was-renamed.stdout
@@ -0,0 +1,18 @@
+d .
+d ./.morph
+d ./.morph/cache
+d ./.morph/cache/gits
+d ./.morph/cache/gits/file_hello
+d ./.morph/cache/gits/file_hello/.git
+d ./.morph/cache/gits/file_morphs
+d ./.morph/cache/gits/file_morphs/.git
+d ./master
+d ./master/.morph-system-branch
+d ./master/baserock:hello
+d ./master/baserock:hello/.git
+d ./master/my-renamed-morphs
+d ./master/my-renamed-morphs/.git
+f ./master/.morph-system-branch/config
+f ./master/baserock:hello/hello.morph
+f ./master/my-renamed-morphs/hello-stratum.morph
+f ./master/my-renamed-morphs/hello-system.morph
diff --git a/tests.branching/morph-repository-stored-in-cloned-repositories.script b/tests.branching/morph-repository-stored-in-cloned-repositories.script
new file mode 100755
index 00000000..bfc5499b
--- /dev/null
+++ b/tests.branching/morph-repository-stored-in-cloned-repositories.script
@@ -0,0 +1,47 @@
+#!/bin/sh
+# Copyright (C) 2012 Codethink Limited
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
+# Verify that morph branch/checkout/edit create repositories that have
+# a "git config morph.repository" option set so that we can
+# identify these repositories later even when the user has renamed or
+# moved their local directories.
+
+set -eu
+
+cd "$DATADIR/workspace"
+
+"$SRCDIR/scripts/test-morph" init
+"$SRCDIR/scripts/test-morph" branch baserock:morphs newbranch
+
+echo "morph.repository in branch root repository:"
+cd "$DATADIR/workspace/newbranch/baserock:morphs"
+git config morph.repository
+echo
+
+cd "$DATADIR/workspace"
+"$SRCDIR/scripts/test-morph" checkout baserock:morphs master
+
+echo "morph.repository in branch root repository of a checkout:"
+cd "$DATADIR/workspace/master/baserock:morphs"
+git config morph.repository
+echo
+
+cd "$DATADIR/workspace/master"
+"$SRCDIR/scripts/test-morph" edit baserock:hello master
+
+echo "morph.repository of an edited repository:"
+cd "$DATADIR/workspace/master/baserock:hello"
+git config morph.repository
diff --git a/tests.branching/morph-repository-stored-in-cloned-repositories.stdout b/tests.branching/morph-repository-stored-in-cloned-repositories.stdout
new file mode 100644
index 00000000..b57f0c1f
--- /dev/null
+++ b/tests.branching/morph-repository-stored-in-cloned-repositories.stdout
@@ -0,0 +1,8 @@
+morph.repository in branch root repository:
+baserock:morphs
+
+morph.repository in branch root repository of a checkout:
+baserock:morphs
+
+morph.repository of an edited repository:
+baserock:hello